Attribute VB_Name = "modDS"
Option Explicit

Public Type tEvent
  T(1023) As Long
  V(1023) As Long
  Cnt As Long
  Sel As Long
  SzV As Long
End Type

Public Ev(2) As tEvent

Private Declare Sub memcpy Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Dim DS As DirectSound8
Dim DSB As IDirectSoundBuffer8
Dim Ar() As Integer
Dim DSBSz As Long

Public Sub Render(ByVal Period As Long, ByVal Transpose As Long)
  Dim Sz As Long
  Dim ArS() As Single
  Dim T As Long
  Dim i As Long
  Dim k As Single
  Dim N As Single
  Dim d As Single
  Dim p0 As Long, p1 As Long, p2 As Long, PP As Long

  Sz = Ev(0).T(Ev(0).Cnt - 1)
  DSBSz = Sz * Period
  If Sz < 1 Then Exit Sub
  i = Ev(0).Cnt: Ev(0).V(i) = Ev(0).V(i - 1): Ev(0).T(i) = 1024
  i = Ev(1).Cnt: Ev(1).V(i) = Ev(1).V(i - 1): Ev(1).T(i) = 1024
  i = Ev(2).Cnt: Ev(2).V(i) = Ev(2).V(i - 1): Ev(2).T(i) = 1024
  ReDim ArS(DSBSz - 1)
  For T = 0 To Sz - 1
    DoEvents
    N = Ev(0).V(p0) + (Ev(0).V(p0 + 1) - Ev(0).V(p0)) * (T - Ev(0).T(p0)) / (Ev(0).T(p0 + 1) - Ev(0).T(p0))
    d = Ev(1).V(p1) + (Ev(1).V(p1 + 1) - Ev(1).V(p1)) * (T - Ev(1).T(p1)) / (Ev(1).T(p1 + 1) - Ev(1).T(p1))
    StSetNote N + Transpose, d * 0.09 + 0.01
    If Ev(0).T(p0 + 1) = T Then p0 = p0 + 1
    If Ev(1).T(p1 + 1) = T Then p1 = p1 + 1
    If Ev(2).T(p2) = T Then
      StHit Ev(2).V(p2) * 0.1 + 0.05
      p2 = p2 + 1
    End If
    For i = 0 To Period - 1
      ArS(PP) = StTick
      If k < Abs(ArS(PP)) Then k = Abs(ArS(PP))
      PP = PP + 1
    Next i
  Next T
  k = 32767 / k
  ReDim Ar(DSBSz - 1)
  For T = 0 To DSBSz - 1
    Ar(T) = ArS(T) * k
  Next T
End Sub

Public Sub DSPlay()
  Const WAVE_FORMAT_PCM As Long = 1
  Dim DSBD As DSBUFFERDESC
  Dim WF As WAVEFORMATEX
  Dim Ptr As Long

  If DSBSz < 1 Then Exit Sub
  Set DS = New DirectSound8
  DS.Initialize ByVal 0
  If Not (DS Is Nothing) Then
    DS.SetCooperativeLevel frmMain.hWnd, DSSCL_NORMAL

    DSBD.dwSize = Len(DSBD)
    DSBD.dwBufferBytes = DSBSz * 2
    DSBD.dwFlags = DSBCAPS_CTRLVOLUME Or DSBCAPS_GLOBALFOCUS
    DSBD.lpwfxFormat = VarPtr(WF)

    WF.wFormatTag = WAVE_FORMAT_PCM
    WF.nChannels = 1
    WF.nSamplesPerSec = 44100
    WF.nBlockAlign = 2
    WF.nAvgBytesPerSec = WF.nSamplesPerSec * WF.nBlockAlign
    WF.wBitsPerSample = 16

    DS.CreateSoundBuffer DSBD, DSB, ByVal 0

    DSB.Lock 0, DSBSz * 2, Ptr, 0, 0, 0, 0
    memcpy ByVal Ptr, Ar(0), DSBSz * 2
    DSB.Unlock Ptr, DSBSz * 2, 0, 0

    DSB.Play 0, 0, DSBPLAY_LOOPING
  End If
End Sub

Public Sub DSStop()
  If Not DSB Is Nothing Then DSB.Stop
  Set DSB = Nothing
  Set DS = Nothing
End Sub
