Attribute VB_Name = "modString"
Option Explicit

Dim StLen As Long
Dim StK1 As Single
Dim StK2 As Single
Dim StP(230) As Single
Dim StS(230) As Single
Dim StF(230) As Single

Dim Ri As Double

Public Function StTick() As Single
  Dim i As Long

  For i = 1 To StLen - 1
    StS(i) = StS(i) + ((StP(i - 1) + StP(i + 1)) * 0.5 - StP(i)) * StF(i)
  Next i
  For i = 1 To StLen - 1
    StS(i) = StS(i) * StK1 + (StS(i - 1) + StS(i + 1)) * StK2
  Next i
  For i = 1 To StLen - 1
    StP(i) = StP(i) + StS(i)
  Next i
  StP(StLen) = StP(StLen) * 0.99 + (Rand - 0.5) * 0.000001
  StTick = StP(1)
End Function

Public Sub StHit(ByVal Vel As Single)
  Dim d As Long
  Dim i As Long
  Dim V As Single

  d = StLen * 0.66
  For i = 1 To d - 1
    V = i / d
    Select Case V
      Case Is < 0.13
        V = V / 0.13
      Case Else
        V = (1 - V) / 0.87
    End Select
    StS(i) = StS(i) + V * Vel
  Next i
End Sub

Public Sub StSetNote(ByVal Note As Single, ByVal Demp As Single)
  Dim s As Single
  Dim Frc As Single
  Dim sLen As Long
  Dim kDemp As Single
  Dim kRand As Single

  If Note <= 24 Then
    Frc = 0.375 * 4 ^ ((Note - 12) / 12)
    sLen = 230
    kDemp = Demp
  Else
    Frc = 1.5
    s = 230 / 2 ^ ((Note - 24) / 12)
    sLen = Int(s)
    Frc = Frc * (sLen / s) * (sLen / s)
    kDemp = Demp * 24 / Note
  End If
  kRand = sLen * 0.001
  StSet Frc, sLen, kDemp, kRand
End Sub

Private Sub StSet(ByVal sFrc As Single, ByVal sLen As Long, ByVal kDemp As Single, ByVal kRand As Single)
  Dim i As Long

'  For i = StLen + 1 To sLen
'    StP(i) = StP(i - 1)
'    StS(i) = StS(i - 1)
'  Next i
  If sLen > StLen Then
    StP(sLen) = 0 'StP(sLen - 1)
    StS(sLen) = 0 'StS(sLen - 1)
  End If
  StLen = sLen
  StK1 = 1 - kDemp * 0.333 * sFrc
  StK2 = (1 - StK1) * 0.5

  For i = 0 To StLen
    StF(i) = sFrc * (1 + (Rand - 0.5) * kRand)
  Next i
End Sub

Private Function Rand() As Single
  Ri = 1.314 * Ri + 1.737
  If Ri > 983732.3456 Then Ri = Ri * 0.3141
  Rand = Ri - Int(Ri)
End Function

Private Sub RandInit(ByVal R As Single)
  Ri = R
End Sub
